'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;

var _Declaration = require('./declaration');

var _Declaration2 = _interopRequireWildcard(_Declaration);

var _Processor = require('./processor');

var _Processor2 = _interopRequireWildcard(_Processor);

var _Comment = require('./comment');

var _Comment2 = _interopRequireWildcard(_Comment);

var _AtRule = require('./at-rule');

var _AtRule2 = _interopRequireWildcard(_AtRule);

var _vendor = require('./vendor');

var _vendor2 = _interopRequireWildcard(_vendor);

var _parse = require('./parse');

var _parse2 = _interopRequireWildcard(_parse);

var _list = require('./list');

var _list2 = _interopRequireWildcard(_list);

var _Rule = require('./rule');

var _Rule2 = _interopRequireWildcard(_Rule);

var _Root = require('./root');

var _Root2 = _interopRequireWildcard(_Root);

var postcss = function postcss() {
    for (var _len = arguments.length, plugins = Array(_len), _key = 0; _key < _len; _key++) {
        plugins[_key] = arguments[_key];
    }

    if (plugins.length === 1 && Array.isArray(plugins[0])) {
        plugins = plugins[0];
    }
    return new _Processor2['default'](plugins);
};

postcss.plugin = function (name, initializer) {
    var creator = function creator() {
        var transformer = initializer.apply(this, arguments);
        transformer.postcssPlugin = name;
        transformer.postcssVersion = _Processor2['default'].prototype.version;
        return transformer;
    };

    creator.postcss = creator();
    return creator;
};

postcss.vendor = _vendor2['default'];

postcss.parse = _parse2['default'];

postcss.list = _list2['default'];

postcss.comment = function (defaults) {
    return new _Comment2['default'](defaults);
};
postcss.atRule = function (defaults) {
    return new _AtRule2['default'](defaults);
};
postcss.decl = function (defaults) {
    return new _Declaration2['default'](defaults);
};
postcss.rule = function (defaults) {
    return new _Rule2['default'](defaults);
};
postcss.root = function (defaults) {
    return new _Root2['default'](defaults);
};

exports['default'] = postcss;
module.exports = exports['default'];