'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

exports.__esModule = true;

var _LazyResult = require('./lazy-result');

var _LazyResult2 = _interopRequireWildcard(_LazyResult);

var Processor = (function () {
    function Processor() {
        var _this = this;

        var plugins = arguments[0] === undefined ? [] : arguments[0];

        _classCallCheck(this, Processor);

        this.plugins = plugins.map(function (i) {
            return _this.normalize(i);
        });
    }

    Processor.prototype.use = function use(plugin) {
        plugin = this.normalize(plugin);
        if (typeof plugin === 'object' && Array.isArray(plugin.plugins)) {
            this.plugins = this.plugins.concat(plugin.plugins);
        } else {
            this.plugins.push(plugin);
        }
        return this;
    };

    Processor.prototype.process = function process(css) {
        var opts = arguments[1] === undefined ? {} : arguments[1];

        return new _LazyResult2['default'](this, css, opts);
    };

    Processor.prototype.normalize = function normalize(plugin) {
        var type = typeof plugin;
        if ((type === 'object' || type === 'function') && plugin.postcss) {
            return plugin.postcss;
        } else {
            return plugin;
        }
    };

    return Processor;
})();

exports['default'] = Processor;

Processor.prototype.version = require('../package').version;
module.exports = exports['default'];